SystemOrganization addCategory: #'FormalConceptAnalysis-Tests'!

Object subclass: #FormalConceptAnalysisExamples
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FormalConceptAnalysis-Tests'!

!FormalConceptAnalysisExamples class methodsFor: 'examples' stamp: 'AndyKellens 7/30/2012 10:10'!
example1
	"self example1" 
	"Ganter & Wille page 28, but with minimum set of countries"

	"23 concepts for 17 countries and 6 organisations"

	
	| ctx arr |
	arr := #(#Afghanistan #(#Group77 #NonAligned #LLDC #MSAC) #Algeria #(#Group77 #NonAligned #OPEC) #Angola #(#Group77 #NonAligned #ACP) #Antigua #(#Group77 #ACP) #Argentina #(#Group77) #Bahrain #(#Group77 #NonAligned) #Benin #(#Group77 #NonAligned #LLDC #MSAC #ACP) #Birma #(#Group77 #LLDC #MSAC) #Buthan #(#Group77 #NonAligned #LLDC) #Botswana #(#Group77 #NonAligned #LLDC #ACP) #Brunei #() #Cambodia #(#Group77 #NonAligned #MSAC) #Cameroon #(#Group77 #NonAligned #MSAC #ACP) #ElSalvador #(#Group77 #MSAC) #Gabon #(#Group77 #NonAligned #OPEC #ACP) #Haiti #(#Group77 #LLDC #MSAC #ACP) #Kiribati #(#LLDC #ACP)).
	ctx := ConceptContext
		fromBlocksForObjects:
			[(1
				to: arr size
				by: 2) collect: [:i | arr at: i]]
		relations: [:country | arr at: (arr indexOf: country) + 1].
	ctx createConcepts.
	ctx conceptDisplayBlock: Concept diffDisplayBlock.
	^ctx! !

!FormalConceptAnalysisExamples class methodsFor: 'examples' stamp: 'AndyKellens 7/30/2012 10:10'!
example2
	"self example2" 
	"generate extents 000 to 111 from extents 011,101,111"

	
	| ctx arr |
	arr := #(#A #(1 2) #B #(1 3) #C #(2 3)).
	ctx := ConceptContext
		fromBlocksForObjects:
			[(1
				to: arr size
				by: 2) collect: [:i | arr at: i]]
		relations: [:number | arr at: (arr indexOf: number) + 1].
	ctx createConcepts.
	^ctx! !

!FormalConceptAnalysisExamples class methodsFor: 'examples' stamp: 'AndyKellens 7/30/2012 10:10'!
example3
	"self example3" 
	
	| ctx arr |
	arr := #(#A #(1 2) #B #(1) #C #(3)).
	ctx := ConceptContext
		fromBlocksForObjects:
			[(1
				to: arr size
				by: 2) collect: [:i | arr at: i]]
		relations: [:country | arr at: (arr indexOf: country) + 1].
	ctx createConcepts.
	^ctx! !

!FormalConceptAnalysisExamples class methodsFor: 'examples' stamp: 'AndyKellens 7/30/2012 10:10'!
example4
	"self example4" 
	"Ganter & Wille frontpage and page 76: waters"

	
	| ctx arr |
	arr := #(#river #(#flowing #natural #large) #brook #(#flowing #natural #small) #canal #(#flowing #artificial #large) #ditch #(#flowing #artificial #small) #lake #(#stagnant #natural #large) #slough #(#stagnant #natural #small) #pond #(#stagnant #artificial #large) #basin #(#stagnant #artificial #small)).
	ctx := ConceptContext
		fromBlocksForObjects:
			[(1
				to: arr size
				by: 2) collect: [:i | arr at: i]]
		relations: [:country | arr at: (arr indexOf: country) + 1].
	ctx createConcepts.
	ctx conceptDisplayBlock: Concept diffDisplayBlock.
	^ctx! !

!FormalConceptAnalysisExamples class methodsFor: 'examples' stamp: 'AK 6/15/2009 16:57'!
example5
	"self example5" 
	
	| ctx baseClass superBaseClase ignoreSelectors |
	baseClass := Integer.
	superBaseClase := baseClass superclass.
	ignoreSelectors := superBaseClase allSelectors.
	ctx := ConceptContext
		fromBlocksForObjects: [baseClass withAllSubclasses]
		relations:
			[:class | class allSelectors reject: [:s | ignoreSelectors includes: s]].
	ctx createConcepts.
	^ctx! !

Object subclass: #RelationalConceptAnalysisExample
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FormalConceptAnalysis-Tests'!

!RelationalConceptAnalysisExample class methodsFor: 'as yet unclassified' stamp: 'AndyKellens 7/30/2012 10:38'!
example
	
	| context |
	context := RelationalConceptContext
		fromBlocksForObjects: [RelationalConceptAnalysisExample new objects]
		relations:
			[:obj | RelationalConceptAnalysisExample new attributes at: obj].
	context
		addRelationWithName: 'cites'
		block: [:obj | RelationalConceptAnalysisExample new cites at: obj].
	context
		addRelationWithName: 'developers'
		block: [:obj | RelationalConceptAnalysisExample new develops at: obj].
	context createRelations! !

!RelationalConceptAnalysisExample methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:27'!
attributes
	
	| dict |
	dict := Dictionary new.
	dict at: 'gw99' put: #('it').
	dict at: 'bm70' put: #('it').
	dict at: 'are03' put: #().
	dict at: 'dic96' put: #().
	dict at: 'arePHD' put: #().
	dict at: 'hucHDR' put: #().
	dict at: 'bot91' put: #('mmi').
	dict at: 'moo96' put: #('se').
	dict at: 'val03' put: #().
	dict at: 'leber02' put: #().
	dict at: 'rouaPHD' put: #().
	dict at: 'leberHDR' put: #().
	^dict! !

!RelationalConceptAnalysisExample methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:27'!
cites
	
	| dict |
	dict := Dictionary new.
	dict at: 'gw99' put: #().
	dict at: 'bm70' put: #().
	dict at: 'are03' put: #('gw99' 'bot91').
	dict at: 'dic96' put: #('bm70' 'moo96').
	dict at: 'arePHD' put: #().
	dict at: 'hucHDR' put: #().
	dict at: 'bot91' put: #().
	dict at: 'moo96' put: #().
	dict at: 'val03' put: #('gw99').
	dict at: 'leber02' put: #('bm70').
	dict at: 'rouaPHD' put: #().
	dict at: 'leberHDR' put: #().
	^dict! !

!RelationalConceptAnalysisExample methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:27'!
develops
	
	| dict |
	dict := Dictionary new.
	dict at: 'gw99' put: #().
	dict at: 'bm70' put: #().
	dict at: 'are03' put: #().
	dict at: 'dic96' put: #().
	dict at: 'arePHD' put: #('are03').
	dict at: 'hucHDR' put: #('dic96').
	dict at: 'bot91' put: #().
	dict at: 'moo96' put: #().
	dict at: 'val03' put: #().
	dict at: 'leber02' put: #().
	dict at: 'rouaPHD' put: #('val03').
	dict at: 'leberHDR' put: #('leber02').
	^dict! !

!RelationalConceptAnalysisExample methodsFor: 'accessing' stamp: 'sp 15/6/09 16:33'!
objects
	
	^#('gw99' 'bm70' 'are03' 'dic96' 'arePHD' 'hucHDR' 'bot91' 'moo96' 'val03' 'leber02' 'rouaPHD' 'leberHDR')! !

TestCase subclass: #FormalConceptContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FormalConceptAnalysis-Tests'!

!FormalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:11'!
testExample1
	
	| concepts |
	concepts := FormalConceptAnalysisExamples example1.
	self assert: concepts concepts size = 23.
	self assert: concepts topConcept intent size = 0.
	self assert: concepts topConcept extent size = 17.
	self assert: concepts bottomConcept intent size = 6.
	self assert: concepts bottomConcept extent size = 0! !

!FormalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:27'!
testExample2
	
	| concepts |
	concepts := FormalConceptAnalysisExamples example2.
	self assert: concepts concepts size = 8.
	self assert: concepts topConcept intent size = 0.
	self assert: concepts topConcept extent size = 3.
	self assert: concepts bottomConcept intent size = 3.
	self assert: concepts bottomConcept extent size = 0! !

!FormalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:27'!
testExample3
	
	| concepts |
	concepts := FormalConceptAnalysisExamples example3.
	self assert: concepts concepts size = 5.
	self assert: concepts topConcept intent size = 0.
	self assert: concepts topConcept extent size = 3.
	self assert: concepts bottomConcept intent size = 3.
	self assert: concepts bottomConcept extent size = 0! !

!FormalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:27'!
testExample4
	
	| concepts |
	concepts := FormalConceptAnalysisExamples example4.
	self assert: concepts concepts size = 28.
	self assert: concepts topConcept intent size = 0.
	self assert: concepts topConcept extent size = 8.
	self assert: concepts bottomConcept intent size = 6.
	self assert: concepts bottomConcept extent size = 0! !

!FormalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:31'!
testExample5
	
	| concepts |
	concepts := FormalConceptAnalysisExamples example5.
	self assert: concepts concepts size = 5.
	self assert: concepts topConcept intent size = 103.
	self assert: concepts topConcept extent size = 4.
	self assert: concepts bottomConcept intent size = 116.
	self assert: concepts bottomConcept extent size = 0! !

TestCase subclass: #RelationalConceptContextTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FormalConceptAnalysis-Tests'!

!RelationalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:27'!
createContext
	
	| context |
	context := RelationalConceptContext
		fromBlocksForObjects: [RelationalConceptAnalysisExample new objects]
		relations:
			[:obj | RelationalConceptAnalysisExample new attributes at: obj].
	context
		addRelationWithName: 'cites'
		block: [:obj | RelationalConceptAnalysisExample new cites at: obj].
	context
		addRelationWithName: 'developers'
		block: [:obj | RelationalConceptAnalysisExample new develops at: obj].
	^context! !

!RelationalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:28'!
testExpansionOfRelations
	
	| context bitpatterns |
	"test if the representation of the relations into bit patterns works as it should"

	context := self createContext.
	context expandRelations.
	bitpatterns := context bitRepRelations at: 'cites'.
	self assert: (bitpatterns at: 1) size = 1.
	self
		assert:
			((bitpatterns at: 1) select: [:wrapper | wrapper wrappedElement = 'val03'])
				size = 1.
	self assert: (bitpatterns at: 2) size = 1.
	self
		assert:
			((bitpatterns at: 2)
				select: [:wrapper | wrapper wrappedElement = 'leber02']) size = 1.
	self assert: (bitpatterns at: 65) size = 1.
	self
		assert:
			((bitpatterns at: 65) select: [:wrapper | wrapper wrappedElement = 'are03'])
				size = 1.
	self assert: (bitpatterns at: 130) size = 1.
	self
		assert:
			((bitpatterns at: 130)
				select: [:wrapper | wrapper wrappedElement = 'dic96']) size = 1! !

!RelationalConceptContextTest methodsFor: 'accessing' stamp: 'AK 6/15/2009 16:56'!
testRCA
	
	| context topConcept bottomConcept currentLevel conceptstrings |
	"test to verify that the RCA algorithm produces the correct lattice"

	context := self createContext.
	context createRelations.	"First check if the numbers of the RCA match up"

	self assert: context concepts size = 9.
	self assert: context attributes size = 8.
	self assert: context objects size = 12.	"top level in the lattice"

	topConcept := context topConcept.
	self assert: topConcept extent = context objects values.
	self assert: topConcept intent isEmpty.
	self assert: topConcept biggerOnes isEmpty.	"level 1 should contain 5 concepts"

	currentLevel := topConcept smallerOnes.
	self assert: currentLevel size = 5.
	conceptstrings := Set new.
	conceptstrings add:
			'{''dic96'' ''leber02'' ''are03'' ''val03''}>{cites:({''bm70'' ''leberHDR'' ''rouaPHD'' ''arePHD'' ''bot91'' ''dic96'' ''leber02'' ''hucHDR'' ''moo96'' ''gw99'' ''are03'' ''val03''}>{})}'.
	conceptstrings add: '{''bm70'' ''gw99''}>{''it''}'.
	conceptstrings add: '{''bot91''}>{''mmi''}'.
	conceptstrings add: '{''moo96''}>{''se''}'.
	conceptstrings add:
			'{''leberHDR'' ''rouaPHD'' ''arePHD'' ''hucHDR''}>{developers:({''bm70'' ''leberHDR'' ''rouaPHD'' ''arePHD'' ''bot91'' ''dic96'' ''leber02'' ''hucHDR'' ''moo96'' ''gw99'' ''are03'' ''val03''}>{}) developers:({''dic96'' ''leber02'' ''are03'' ''val03''}>{cites:({''bm70'' ''leberHDR'' ''rouaPHD'' ''arePHD'' ''bot91'' ''dic96'' ''leber02'' ''hucHDR'' ''moo96'' ''gw99'' ''are03'' ''val03''}>{})})}'.
	self
		assert:
			(conceptstrings = (currentLevel collect: [:concept | concept asString]) ).	"bottom concept of the lattice"

	bottomConcept := context bottomConcept.
	self assert: bottomConcept extent isEmpty.
	self assert: bottomConcept intent = context attributes values.
	self assert: bottomConcept smallerOnes isEmpty.	"level two should contain 5 concepts"

	currentLevel := bottomConcept biggerOnes.
	self assert: currentLevel size = 5.
	conceptstrings := Set new.
	conceptstrings add: '{''bm70'' ''gw99''}>{''it''}'.
	conceptstrings add: '{''bot91''}>{''mmi''}'.
	conceptstrings add: '{''moo96''}>{''se''}'.
	conceptstrings add:
			'{''leberHDR'' ''rouaPHD''}>{developers:({''bm70'' ''leberHDR'' ''rouaPHD'' ''arePHD'' ''bot91'' ''dic96'' ''leber02'' ''hucHDR'' ''moo96'' ''gw99'' ''are03'' ''val03''}>{}) developers:({''dic96'' ''leber02'' ''are03'' ''val03''}>{cites:({''bm70'' ''leberHDR'' ''rouaPHD'' ''arePHD'' ''bot91'' ''dic96'' ''leber02'' ''hucHDR'' ''moo96'' ''gw99'' ''are03'' ''val03''}>{})}) developers:({''leber02'' ''val03''}>{cites:({''bm70'' ''gw99''}>{''it''}) cites:({''bm70'' ''leberHDR'' ''rouaPHD'' ''arePHD'' ''bot91'' ''dic96'' ''leber02'' ''hucHDR'' ''moo96'' ''gw99'' ''are03'' ''val03''}>{})})}'.
	conceptstrings add:
			'{''leber02'' ''val03''}>{cites:({''bm70'' ''gw99''}>{''it''}) cites:({''bm70'' ''leberHDR'' ''rouaPHD'' ''arePHD'' ''bot91'' ''dic96'' ''leber02'' ''hucHDR'' ''moo96'' ''gw99'' ''are03'' ''val03''}>{})}'.
	self
		assert:
			(conceptstrings
				= (currentLevel collect: [:concept | concept asString]))! !

!RelationalConceptContextTest methodsFor: 'accessing' stamp: 'AndyKellens 7/30/2012 10:29'!
testScaling
	
	| context relationattributes |
	"test of the scaling operation that extends the set of attributes of the FCA"

	context := self createContext.
	context createConcepts.	"First check if the numbers of the FCA match up"

	self assert: context concepts size = 5.
	self assert: context attributes size = 3.
	self assert: context objects size = 12.	"Perform scaling over the cites relationship"

	context expandRelations.
	context
		scalingForConcepts: context concepts
		forRelationship: (context bitRepRelations at: 'cites')
		withName: 'cites'.
	self assert: context attributes size = 5.	"There should now be two extra attributes, namely the matches for the cites relationship"

	relationattributes := context attributes keys
		select: [:attribute | attribute isKindOf: RelationAttribute].
	self assert: relationattributes size = 2! !
